// Ethernet preamble
  7'h00: arp_data <= 8'h55;
  7'h01: arp_data <= 8'h55;
  7'h02: arp_data <= 8'h55;
  7'h03: arp_data <= 8'h55;
  7'h04: arp_data <= 8'h55;
  7'h05: arp_data <= 8'h55;
  7'h06: arp_data <= 8'h55;
  7'h07: arp_data <= 8'hD5; // SOF mark

// Ethernet header
  7'h08: arp_data <= DestMACAddress_1;
  7'h09: arp_data <= DestMACAddress_2;
  7'h0A: arp_data <= DestMACAddress_3;
  7'h0B: arp_data <= DestMACAddress_4;
  7'h0C: arp_data <= DestMACAddress_5;
  7'h0D: arp_data <= DestMACAddress_6;
  7'h0E: arp_data <= SrcMACAddress_1;
  7'h0F: arp_data <= SrcMACAddress_2;
  7'h10: arp_data <= SrcMACAddress_3;
  7'h11: arp_data <= SrcMACAddress_4;
  7'h12: arp_data <= SrcMACAddress_5;
  7'h13: arp_data <= SrcMACAddress_6;
  7'h14: arp_data<= Lo_Prot_Type_ARP[15:8]; // Type code : &H'0800 > IP Packet, &H'0806 > ARP packet	&H'8035 > ARP/RARP
  7'h15: arp_data<= Lo_Prot_Type_ARP[7:0]; // lo byte
  	 
 // ARP header
  7'h16: arp_data <= HW_Type[15:8];  // Hardware type 0001> ethernet
  7'h17: arp_data <= HW_Type[7:0];  // 
  7'h18: arp_data <= Hi_Prot_Type[15:8];   // Higher protocol supported IP> 0800 
  7'h19: arp_data <= Hi_Prot_Type[7:0];   // 
  7'h1A: arp_data <= H_Len;  	// 	Length of Hware adress  Ethernet > 6  
  7'h1B: arp_data <= P_Len;   // 	Length of Protocol address Internet > 4
  7'h1C: arp_data <= ARP_Op[15:8];  //    ARP req > 0001 ARP resp> 0002
  7'h1D: arp_data <= ARP_Op[7:0];   // 
  7'h1E: arp_data <= SrcMACAddress_1;
  7'h1F: arp_data <= SrcMACAddress_2;
  7'h20: arp_data <= SrcMACAddress_3;
  7'h21: arp_data <= SrcMACAddress_4;
  7'h22: arp_data <= SrcMACAddress_5;
  7'h23: arp_data <= SrcMACAddress_6;
  7'h24: arp_data <= IPsource_1;
  7'h25: arp_data <= IPsource_2;
  7'h26: arp_data <= IPsource_3;
  7'h27: arp_data <= IPsource_4;
  7'h28: arp_data <= DestMACAddress_1; // 
  7'h29: arp_data <= DestMACAddress_2; // 
  7'h2A: arp_data <= DestMACAddress_3; // 
  7'h2B: arp_data <= DestMACAddress_4; // 
  7'h2C: arp_data <= DestMACAddress_5; // 
  7'h2D: arp_data <= DestMACAddress_6; // 
  7'h2E: arp_data <= IPdestination_1; // 
  7'h2F: arp_data <= IPdestination_2; //
  7'h30: arp_data <= IPdestination_3; //
  7'h31: arp_data <= IPdestination_4; //

// data frame - padding
  7'h32: arp_data <= Dummy_Data_A[15:8];   // Dummy data HI
  7'h33: arp_data <= Dummy_Data_A[7:0];   //  Dummy data LO
  7'h34: arp_data <= Data_In; // dodati Rd_En i ispitati timing
  7'h35: arp_data <= Data_In; // FIFO ili DPRam ?
  7'h36: arp_data <= Data_In; // 
  7'h37: arp_data <= Data_In; // 
  7'h38: arp_data <= Data_In; // 
  7'h39: arp_data <= Data_In; // 
  7'h3A: arp_data <= Data_In; // 
  7'h3B: arp_data <= Data_In; // 
  7'h3C: arp_data <= Data_In; // 
  7'h3D: arp_data <= Data_In; // 
  7'h3E: arp_data <= Data_In; // 
  7'h3F: arp_data <= Data_In; // 
  7'h40: arp_data <= Data_In; // 
  7'h41: arp_data <= Data_In; // 
  7'h42: arp_data <= Data_In; // 
  7'h43: arp_data <= Data_In; // 

default: arp_data <= 8'bx;	