module clkgenerator( clk50, clk80, clk20, clk160, clkUART);

input clk50;
output clk20, clk80, clk160, clkUART;

wire clk160;
reg [2:0] countera; always @(posedge clk160) countera<=countera +1;
wire clk20=countera[2];	wire clk80=countera[0];


parameter ClkFrequency = 160000000; // 160MHz
parameter Baud = 115200; //921600
parameter Oversample=16;
parameter BaudOver = Baud*Oversample; //x times oversampling
parameter BaudOverGeneratorAccWidth = 16;
parameter BaudOverGeneratorInc = ((BaudOver<<(BaudOverGeneratorAccWidth-7))+
                                 (ClkFrequency>>8))/(ClkFrequency>>7);
reg [BaudOverGeneratorAccWidth:0] BaudOverGeneratorAcc;
always @(posedge clk160) BaudOverGeneratorAcc <= BaudOverGeneratorAcc[BaudOverGeneratorAccWidth-1:0] + 
                                 BaudOverGeneratorInc;
wire clkUART = BaudOverGeneratorAcc[BaudOverGeneratorAccWidth];


DCM DCM_INST(
    .CLKIN (clk50), .CLKFB (),
    .RST (),
    .PSEN (1'b0),
    .PSINCDEC (1'b0),
    .PSCLK (1'b0),
    .DSSEN (1'b0),
    .CLK0 (), .CLK90 (), .CLK180 (), .CLK270 (), .CLKDV (),
    .CLK2X (), .CLK2X180 (),
    .CLKFX (clk160), .CLKFX180 (),
    .STATUS (),
    .LOCKED (),
    .PSDONE ());

 defparam DCM_INST.CLK_FEEDBACK="1X";
 defparam DCM_INST.CLKDV_DIVIDE=2;
 defparam DCM_INST.CLKFX_DIVIDE=5;
 defparam DCM_INST.CLKFX_MULTIPLY=16;
 defparam DCM_INST.CLKIN_DIVIDE_BY_2="FALSE";
 defparam DCM_INST.CLKIN_PERIOD=20;
 defparam DCM_INST.CLKOUT_PHASE_SHIFT="NONE";
 defparam DCM_INST.DESKEW_ADJUST="SYSTEM_SYNCHRONOUS";
 defparam DCM_INST.DFS_FREQUENCY_MODE="LOW";
 defparam DCM_INST.DLL_FREQUENCY_MODE="LOW";
 defparam DCM_INST.DUTY_CYCLE_CORRECTION="TRUE";
 defparam DCM_INST.PHASE_SHIFT=0;
 defparam DCM_INST.STARTUP_WAIT="FALSE";

endmodule
