module tenbasetrxd( clk80, manchester_data_in, data, new_byte_available);	

input clk80, manchester_data_in;
output [7:0]data;
output new_byte_available; 
//-----------------------------------------------------------------------------------------------------
//Manchester decoder najstabilnija verzija : Otpada za 100_tx
	reg new_bit_avail;
 	reg [4:0]in_data;
	always @ (posedge clk80 )  in_data[0]<=manchester_data_in;
	always @ (posedge clk80 )	in_data[1]<=~in_data[0];
   always @ (posedge clk80 )	in_data[2]<=(((in_data[0] ^ ~in_data[1]) | in_data[2]) & ~in_data[4]);
	always @ (posedge clk80 )	in_data[3]<= in_data[2];
	always @ (posedge clk80 )	in_data[4]<=(in_data[2] | in_data[4]) & in_data[3];
   always @ (posedge clk80 )	new_bit_avail<=(in_data[0] ^ ~in_data[1]) & ~in_data[2]  & ~in_data[4];
//----------------------------------------------------------------------------------------
//Deserializer	 : Otpada za 100_tx
reg [7:0] data;
always @(posedge clk80) if(new_bit_avail) data<={in_data[1],data[7:1]};
//---------------------------------------------------------------------------------------
// end of the Ethernet frame : Otpada za 100_tx
reg end_of_Ethernet_frame;
reg [2:0] transition_timeout;
always @(posedge clk80) if(in_data[1]^~in_data[0]) transition_timeout<=0; 
else if(~new_bit_avail) transition_timeout<=transition_timeout+1;
always @(posedge clk80)  end_of_Ethernet_frame<= &transition_timeout;
//---------------------------------------------------------------------------------------
//Preamble receiver	: Mozda otpada za 100_tx: vidi dokumentaciju
reg [4:0] sync1;
always @(posedge clk80)
if(end_of_Ethernet_frame) sync1<=0; 
  else 
if(new_bit_avail) 
begin
  if(!(data==8'h55 || data==8'hAA)) // not preamble?
    sync1 <= 0;
  else
  if(~&sync1) //  preamble received, so stop counting and wait for "sync2" to detect the SFD,
     sync1 <= sync1 + 1; //  otherwise keep counting
end
//-------------------------------------------------------------------------------------
//SOF Detector	 : Isto kao i gore  : dovrsiti komentare ispod : ubaciti IP/UDP state machine, presloziti kod
reg [9:0] sync2;
always @(posedge clk80)
if(end_of_Ethernet_frame)
  sync2 <= 0;
else 
if(new_bit_avail) 
begin
  if(|sync2) // if the SFD has already been detected (Ethernet data is coming in)
    sync2 <= sync2 + 1; // then count the bits coming in
  else
  if(&sync1 && (data==8'hD5||data==8'h2A)) // otherwise, let's wait for the SFD (0xhD5 or 0xh2A): srediti polarity correct
    sync2 <= sync2 + 1;
end

reg new_byte_available;
always @(posedge clk80) new_byte_available <=(sync2[2:0]==3'h0) && (sync2[9:3]!=0);//!!!!  new_bit_avail &&

endmodule